eval '(exit $?0)' && eval 'PERL=`which perl`; exec $PERL -wS $0 ${1+"$@"}'
    & eval 'setenv PERL `which perl5`; exec $PERL -wS $0 $argv:q'
    if 0;

### Local Variables: ***
### mode:perl ***
### comment-column:0 ***
### comment-start: "### " ***
### comment-end: "***" ***
### End: ***
#
# ****************DO NOT MOVE OR CHANGE LINES ABOVE THIS*********************
#
# The first set of lines runs perl from any shell. The second set of lines 
# identifies the rest of the file as PERL for EMACS autoformatting. 
# See end of copyright for more information.
#
# 
# -------------------------------------------------------------------
#                                   X-BONE
#
#                          http://www.isi.edu/xbone
#                USC Information Sciences Institute (USC/ISI)
#                   Marina del Rey, California 90292, USA
#                          Copyright (c) 1998-2005
# 
# -------------------------------------------------------------------
#
# Copyright (c) 1998-2005 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation in source and binary forms for non-commercial
# purposes and without fee is hereby granted, provided that the above
# copyright notice appear in all copies and that both the copyright
# notice and this permission notice appear in supporting
# documentation, and that any documentation, advertising materials,
# and other materials related to such distribution and use acknowledge
# that the software was developed by the University of Southern
# California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived
# from this software without specific prior written permission.
# 
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT
# THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS
# PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so
# noted when applicable.
#
# -------------------------------------------------------------------
#  $RCSfile: alndb.pl,v $
#
# $Revision: 1.14 $
#   $Author: pingali $
#     $Date: 2006/01/11 18:31:36 $
#    $State: Exp $
# ----------------------------------------------------------------------------

# The first lines start PERL on any system where perl is in the path.
# This is a modified version of the "start perl" script provided in
# the PERL man pages, which starts perl on the remainder of the file
# regardless of whether it is run under sh, csh, or perl.
#
# This version is modified to dynamically locate the perl path, rather
# than requiring it be hard-coded.


package ALNDB; 

use strict;

BEGIN {
    use strict;
    use sigtrap;
    use FindBin;

    my $ldir = $FindBin::RealBin;
    unshift @INC, $ldir;
    unshift @INC, "$ldir/Lib";

}

use DBI();
use Geo::IP::PurePerl qw(GEOIP_MEMORY_CACHE GEOIP_STANDARD);
use Data::Dumper; 
use Weather::Underground;

use Data::Dumper;
use Time::Format;

use Date::Calendar::Profiles qw( $Profiles );
use Date::Calendar;

use Location qw(GEOIP_MEMORY_CACHE GEOIP_STANDARD );

use ALNConfig qw (variables maxvalues); 

my $modname = "ALNDB::"; 
my $trace = 0; # Debug level for the database query
my %defaults = (); 

# Description:
#     Open the DBI connection
#     
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub open_dbh($){


    my ($conf) = @_; 
    my $procname = "open_dbh"; 

    my $database = $conf->{'database'}; 
    my $username = $conf->{'username'}; 
    my $password = $conf->{'password'}; 
    my $hostname = $conf->{'hostname'}; 
    my $dbh; 

    eval { 

	# Connect to the database.
	$dbh = DBI->connect("DBI:mysql:database=$database;host=$hostname",
			    $username, $password, 
			    {RaiseError => 1});
	
	$dbh->trace($trace); 
    };
    
    print "Cannot open a connection to the mysql database\n" if ($@);
    
    return $dbh unless ($@); 
    die($procname); 

};

# Description:
#     Identifies the new destination addresses in the database, 
#     obtains their location information and dumps it into another 
#     table. 
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub update_location_table($) { 

    my ($conf) = @_; 
    my $procname = "update_location_table"; 

    
    eval { 

	#my $geodb = Geo::IP::PurePerl->new(GEOIP_MEMORY_CACHE);
	my $geodb = Geo::IP::PurePerl->new
	    ("/usr/local/share/GeoIP/GeoIPCity.dat", 
	     Geo::IP::PurePerl::GEOIP_STANDARD);
	
	die ("geodb") if (not defined $geodb); 

	# look up IP address '24.24.24.24'
	# returns undef if country is unallocated, or not defined in our database
	
	# Connect to the database.
	my $dbh = open_dbh($conf); 

	# Select all destination whos location has not already stored in the 
	# database 
	my $sqlquery = 
	    "SELECT DISTINCT LocalAddressType, RemAddress FROM exit_stats WHERE " . 
	    "((LocalAddressType = 1) AND ".
	    "(NOT EXISTS (SELECT location_Address FROM location WHERE ".
	    "exit_stats.RemAddress = location_Address)));"; 
	
	my $sth = $dbh->prepare($sqlquery); 
	$sth->execute();

	print "Finished executing the squery to find new entries..." . time . "\n"; 	
	
	# For each row...
	my $count = 0; 
	while (my $ref = $sth->fetchrow_hashref()) {
	    my $Address = $ref->{RemAddress}; 
	    my $AddressType = $ref->{LocalAddressType}; 
	    
	    
	    # Obtain the destination information 
	    my ($CountryCode,$CountryCode3,$CountryName,$Region,$City,
		$PostalCode,$Latitude,$Longitude,$dma_code,$area_code) = 
		    $geodb->get_city_record($Address);

	    # if not defined, then assign null string...
	    foreach my $var (\$City, 
			     \$Region, \$CountryCode, \$CountryCode3, 
			     \$CountryName, \$Latitude, \$Longitude, 
			     \$PostalCode){
		$$var = "-" if ((not defined $$var) or ($$var eq "")); 
	    }; 
	    
	    # Dont insert entries that are incomplete
	    next if (($CountryCode eq "-") or ($City eq "-"));

	    my @cmd = ("insert into location values (?,?,?,?,?,?,?,?,?,?)",
		       undef, 
		       $AddressType, $Address, $City, $Region, 
		       $CountryCode, $CountryCode3, 
		       $CountryName, $Latitude, $Longitude, $PostalCode); 
	    
	    $dbh->do(@cmd); 
	    $count++; 
	    print "Finished...$count \n" if (($count & 0xff) ==0); 
	    
	}; # for each new address...
	
	print "Finished inserting new entries..." . time . "\n";

	# Cleanup
	$sth->finish();

	# Disconnect from the database.
	$dbh->disconnect();
	
	
    }; #eval 

    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@ =~ /\b(geodb)\b/) {
	print "warning". "   ! $procname caught unknown exception: $@";
      }
    
    return 0; 
    
};


# Description:
#     Convert the connection time into day of the week..
#     
#     
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub update_quantize_table($) { 

    my ($conf) = @_; 
    my $procname = "update_quantize_table"; 

    eval { 
	
	#=> Dummy data.....
	my $rtt_sample_quantization_table = 
	   [
	    #  varname  qtype    minval   maxval    enum  quantizedval
	    ["MinRTT",  "range",      0,      20,      0,       5], 
	    ["MinRTT",  "range",     21,      80,      1,      50], 
	    ["MinRTT",  "range",     81,     200,      2,     150], 
	    ["MinRTT",  "range",    201,   99999,      3,     300], 
	    
	    ["MaxRTT",  "range",      0,      20,      0,       5], 
	    ["MaxRTT",  "range",     21,      80,      1,      50], 
	    ["MaxRTT",  "range",     81,     200,      2,     150], 
	    ["MaxRTT",  "range",    201,   99999,      3,     300], 

	    ["PktsIn",  "log10",      0,      1,       0,       5], 
	    ["PktsIn",  "log10",      1,      2,       1,      50], 
	    ["PktsIn",  "log10",      2,      3,       2,     500], 
	    ["PktsIn",  "log10",      3,     10,       3,    5000], # upto 10^10

	    ["PktsOut", "log10",      0,      1,       0,       5], 
	    ["PktsOut", "log10",      1,      2,       1,      50], 
	    ["PktsOut", "log10",      2,      3,       2,     500], 
	    ["PktsOut", "log10",      3,     10,       3,    5000], # upto 10^10

	    ["MaxCwnd", "log10",      0,      4,       0,    5000], # upto 10K bytes
	    ["MaxCwnd", "log10",      4,      5,       1,   50000], # upto 100K
	    ["MaxCwnd", "log10",      5,     10,       2,  500000], # everything else...


	    ];

	# Connect to the database.
	my $dbh = open_dbh($conf); 	
	foreach my $entry (@{$rtt_sample_quantization_table}){
	    my @cmd = ("insert into quantize values (?,?,?,?,?,?)",
		       "undef", @{$entry});
	    #print Dumper(\@cmd);

	    $dbh->do(@cmd); 
	}; # for each new address...
	
	# Disconnect from the database.
	$dbh->disconnect();
	
	
    }; #eval 

    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@) {
	print "warning". "   ! $procname caught unknown exception: $@";
      }
    
    return 0; 
    
};


# Description:
#     Convert the connection time into day of the week..
#     
#     
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub update_time_table($) { 

    my ($conf) = @_; 
    my $procname = "update_time_table"; 

    eval { 
	
	# Connect to the database.
	my $dbh = open_dbh($conf); 
	
	print "Starting executing the squery to find new entries..." . time . "\n"; 	

	# Select all destination whos location has not already stored in the 
	# database 
	my $sqlquery = 
	    "SELECT DISTINCT StartTimeSec FROM exit_stats WHERE " . 
	    "((LocalAddressType = 1) AND ".
	    "(NOT EXISTS (SELECT time_StartTimeSec FROM time WHERE ".
	    "exit_stats.StartTimeSec = time_StartTimeSec)));"; 
	
	my $sth = $dbh->prepare($sqlquery); 
	$sth->execute();
	
	print "Finished executing the squery to find new entries..." . time . "\n"; 	

	# For each row...
	while (my $ref = $sth->fetchrow_hashref()) {
	    my $time = $ref->{StartTimeSec}; 
	    
	    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
		localtime($time);
	    
	    $sec++;        # 1-60 instead of 0-59
	    $min++;        # 1-60 instead of 0-59
	    $hour++;       # 1-24 instead of 0-23
	    #$mday++;      # day of the month does not need fixing.
	    $mon++;        # 1-12 instead of 0-11
	    $year += 1900; # year starts from 1900. 
	    $wday ++;      # 1-7 instead of 0-6
            $yday++;       # 1-365 instead of 0-364
	    

	    my @cmd = ("insert into time values (?,?,?,?,?,?,?,?,?,?)",
		       undef, 
		       $time, $sec, $min, $hour, $mday, $mon, $year, 
		       $wday, $yday, $isdst); 
	    
	    $dbh->do(@cmd); 
	    
	}; # for each new address...
	
	# Cleanup
	$sth->finish();

	# Disconnect from the database.
	$dbh->disconnect();
	
	
    }; #eval 

    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@) {
	print "warning". "   ! $procname caught unknown exception: $@";
      }
    
    return 0; 
    
};


# Description:
#     Generate the city, region, countrycode, countrycode3, countryname
#     
#     
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub update_strings_table($) { 

    my ($conf) = @_; 
    my $procname = "update_strings_table"; 

    eval { 
	
	#=> Cleanup the old table...
	init_table($conf, "strings");

	my $geodb = Location->new("/usr/local/share/GeoIP/GeoIPCity.dat", 
				  Location::GEOIP_STANDARD);
	print "Generating strings from the Geo::IP database. This will ".
	    "take several minutes..\n";
	my ($data) = $geodb->get_all_city_records();

	#=> Now connect to the database.
	my $dbh = open_dbh($conf); 
	
	foreach my $tag (sort keys %{$data}){
	    my $count = 1; 
	    foreach my $tagval (sort keys %{$data->{$tag}}){ 
		my @cmd = ("insert into strings values (?,?,?)",
			   undef ,
			   $tag, $tagval, $count);
		
		$dbh->do(@cmd); 
		$count++; 
	    };
	}; 

	# Disconnect from the database.
	$dbh->disconnect();
	
	
    }; #eval 

    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@) {
	print "warning". "   ! $procname caught unknown exception: $@";
      }
    
    return 0; 
    
};


## Description:
##     Update the holiday information...
##     
##     
## Arguments:
##     -
## Returns:
##     -
## Exceptions:
##     -
#sub update_holidays_table($) { 
#
#    my ($conf) = @_; 
#    my $procname = "update_holidays_table"; 
#
#    eval { 
#	
#	# Connect to the database.
#	my $dbh = open_dbh($conf); 
#	
#	# Select all destination whos location has not already stored in the 
#	# database 
#	my $sqlquery = 
#	   ' SELECT DISTINCT location_CountryCode FROM location WHERE 
#             ((location_Address != "unknown/location") AND
#	      (NOT EXISTS 
#                     (SELECT holidays_Country FROM holidays 
#                         WHERE holidays_Country = location.location_CountryCode
#                      )
#              )
#             );
#           ';
#        
#	my $sth = $dbh->prepare($sqlquery); 
#	$sth->execute();
#	
#	# For each row...
#	while (my $ref = $sth->fetchrow_hashref()) {
#	    my $country = $ref->{location_CountryCode}; 
#	    
#	    print "country = $country\n";
#
#	    eval { 
#
#		my $cal = Date::Calendar::Year->new(2005, {} );
#		
#		die ("Unknown") if (not defined $Profiles->{$country}); 
#
#		$cal->init( 2005, $Profiles->{$country});		
#		
#		# Extract the list of days for which holiday tags are
#		# attached. 
#
#		my $vec = $cal->vec_full(); 
#		my $string = $vec->to_Enum();		
#		my @unfilteredlist = split(',', $string);
#		my @filteredlist = ();
#		while (my $entry = shift @unfilteredlist){
#		    if ($entry =~ /(\d+)-(\d+)/) {
#			foreach my $num ($1 .. $2){ push @filteredlist, $num; }
#		    } else {
#			push @filteredlist, $entry;
#		    }
#		}; 
#		
#		foreach my $day (@filteredlist) {		    
#		    my $hashref  = $cal->tags($day);
#		    if (keys %{$hashref}){
#			my @holidaysondate = keys %{$hashref};
#			my $holidayname = shift @holidaysondate;  
#			
#			my @cmd = ("insert into holidays values (?,?,?,?)",
#				   undef ,
#				   $country, 2005, $day, $holidayname);
#		    
#			$dbh->do(@cmd); 
#			
#		    }
#		}
#
#	    }; #eval...
#	    
#	    if ($@){
#		print "Could not obtain the holidays of $country\n " . $@; 
#	    }
#	    
#	}; # for each new address...
#	
#	# Cleanup
#	$sth->finish();
#	
#	# Disconnect from the database.
#	$dbh->disconnect();
#	
#	
#    }; #eval 
#    
#    #log "info", "<- $modname$procname $@";
#    return 1 unless $@;
#    
#    unless($@ =~ /\b(Unknown)\b/) {
#	print "warning". "   ! $procname caught unknown exception: $@";
#    }
#    
#    return 0; 
#    
#};



# Description:
#     Update the holiday information...
#     This stores holidays for possible countries derived from the 
#     holidays perl module. 
#
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub update_holidays_table($) { 

    my ($conf) = @_; 
    my $procname = "update_holidays_table"; 

    eval { 
	
	# Connect to the database.
	my $dbh = open_dbh($conf); 
	
	my @allcodes = Location::get_all_countrycodes(); 
	my %existingcodes = (); 

	# Select all countries whos holiday information is not
	# already stored in the database
	my $sqlquery = 
	   ' SELECT DISTINCT holidays_Country FROM holidays WHERE 
                                 (holidays_Country != "ZZ");
           ';
	my $sth = $dbh->prepare($sqlquery); 
	$sth->execute();	
	while (my $ref = $sth->fetchrow_hashref()) {
	    my $country = $ref->{holidays_Country};
	    $existingcodes{$country} = 1; 
	};
	
	#=> Find the countries whose holiday list has to be updated...
	foreach my $country (@allcodes){ 
	    next if (not defined $country or exists $existingcodes{$country}); 	    
	    print "processing $country\n";

	    eval { 

		my $cal = Date::Calendar::Year->new(2005, {} );
		
		die ("Unknown") if (not defined $Profiles->{$country}); 

		$cal->init( 2005, $Profiles->{$country});		
		
		# Extract the list of days for which holiday tags are
		# attached. 

		my $vec = $cal->vec_full(); 
		my $string = $vec->to_Enum();		
		my @unfilteredlist = split(',', $string);
		my @filteredlist = ();
		while (my $entry = shift @unfilteredlist){
		    if ($entry =~ /(\d+)-(\d+)/) {
			foreach my $num ($1 .. $2){ push @filteredlist, $num; }
		    } else {
			push @filteredlist, $entry;
		    }
		}; 
		
		foreach my $day (@filteredlist) {		    
		    my $hashref  = $cal->tags($day);
		    if (keys %{$hashref}){
			my @holidaysondate = keys %{$hashref};
			my $holidayname = shift @holidaysondate;  
			
			my @cmd = ("insert into holidays values (?,?,?,?)",
				   undef ,
				   $country, 2005, $day, $holidayname);
		    
			$dbh->do(@cmd); 
			
		    }
		}

	    }; #eval...
	    
	    if ($@){
		print "Could not obtain the holidays of $country\n " . $@; 
	    }
	    
	}; # for each new address...
	
	# Cleanup
	$sth->finish();
	
	# Disconnect from the database.
	$dbh->disconnect();
	
	
    }; #eval 
    
    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@ =~ /\b(Unknown)\b/) {
	print "warning". "   ! $procname caught unknown exception: $@";
    }
    
    return 0; 
    
};

# Description:
#     Update the weather information...
#     
#     
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub update_weather_table($) { 

    my ($conf) = @_; 
    my $procname = "update_weather_table"; 

    
    eval { 
	
	# Connect to the database.
	my $dbh = open_dbh($conf); 
	
	# Select all destination whos location has not already stored in the 
	# database 
	
        # Process all connections within half a day of _now_  and 
        # the start time...
	my $sqlquery = 
            'SELECT DISTINCT location.location_City,
                             location.location_Region, 
                             location.location_CountryCode3, 
                             location.location_CountryName
	     FROM exit_stats, location WHERE 
	     (
               (exit_stats.RemAddress = location.location_Address) AND 
               (exit_stats.StartTimeSec + 43200 > UNIX_TIMESTAMP()) AND
	       (NOT EXISTS (SELECT weather_TimeStamp FROM weather WHERE 
		       (
	         	((exit_stats.StartTimeSec + 21600 > weather_TimeStamp) OR
	         	 (weather_TimeStamp + 21600 > exit_stats.StartTimeSec )) AND 
                        (location.location_City = weather_City) AND 
                        (location.location_CountryCode3 = weather_CountryCode3)
	               )
                      )
               )
             );
            ';

	my $sth = $dbh->prepare($sqlquery); 
	$sth->execute();
	
	# For each row...
	while (my $ref = $sth->fetchrow_hashref()) {
	    my $time = time; 
	    my $city = $ref->{location_City}; 
	    my $region = $ref->{location_Region}; 
	    my $countrycode3 = $ref->{location_CountryCode3}; 
	    my $countryname = $ref->{location_CountryName}; 
	    
	    #print "processing: $time, $city, $region, $countrycode3, $countryname\n"; 
	    eval { 
		
		my ($weather, $arrayref) = (undef, undef);
		
		foreach my $location ( "$city, $region", "$city, $countrycode3", 
				       "$city, $countryname") { 
				       
		    eval { 
			$weather = 
			    Weather::Underground->new(
						      place => $location, 
						      debug => 0,
						      ) or 
			      do {
				   print "Error, could not create new weather object: $@\n";
				   die("weather");
			       };
			
			$arrayref = $weather->get_weather() || do {
			    print "Error get_weather() failed: $@\n";
			    die("weather");
			};
		    }; 
		    
		    if ($@) {
			#print "Could not obtain information for $location\n";
			next; 
		    }
		    #print "Yeah! Obtained information for $location\n";
		    last; 
		};
		
		die "arrayref" if (not defined $arrayref); 

		my $celsius = $arrayref->[0]->{celsius};
		my $fahrenheit = $arrayref->[0]->{fahrenheit};
		my $temperature_celsius = $arrayref->[0]->{temperature_celsius};
		my $temperature_fahrenheit = $arrayref->[0]->{temperature_fahrenheit};
		my $pressure = $arrayref->[0]->{pressure};
		my $conditions = $arrayref->[0]->{conditions};
		
		foreach my $var ( \$celsius, \$fahrenheit, \$pressure, \$conditions){
		    $$var = "-" if (not defined $$var); 
		}; 
		
		my @cmd = ("insert into weather values (?,?,?,?,?,?,?,?,?,?)",		
			   undef, $time, $city, $region, $countrycode3, 
			   $celsius, $fahrenheit,
			   $temperature_celsius, $temperature_fahrenheit,
			   $conditions, $pressure); 
		
		
		$dbh->do(@cmd); 

	    }; #eval...
	    
	    if ($@){
		#print "Could not obtain the weather for $city, $countrycode3, $countryname\n " . $@; 
	    }
	    
	}; # for each new address...
	
	# Cleanup
	$sth->finish();
	
	# Disconnect from the database.
	$dbh->disconnect();
	
	
    }; #eval 
    
    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@ =~ /\b(weather|arrayref)\b/) {
	print "warning". "   ! $procname caught unknown exception: $@";
    }
    
    return 0; 
    
};


# Description:
#     Update the specified table...
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub update_table($$) { 

    my ($conf, $table) = @_; 
    my $procname = "update_table"; 

    
    eval { 
	die "table" if ($table !~ /(location|holidays|time|weather|strings|quantize)/i); 
	
	$_ = $table; 
        SWITCH: { 
	  
	  /(location)/i and do { 
	      update_location_table($conf); 
	      
	      last SWITCH; 
	  }; 

	  /(time)/i and do { 
	      update_time_table($conf); 
	      last SWITCH; 
	  }; 
	  

	  /(holidays)/i and do { 
	      update_holidays_table($conf); 
	      last SWITCH; 
	  }; 

	  /(weather)/i and do { 
	      update_weather_table($conf); 
	      last SWITCH; 
	  }; 

	  /(strings)/i and do { 
	      update_strings_table($conf); 
	      last SWITCH; 
	  }; 

	  /(quantize)/i and do { 
	      update_quantize_table($conf); 
	      last SWITCH; 
	  }; 
	  
	  die ("table"); 
      }

    }; #Eval 

    #log "info", "<- $modname$procname $@";
    return 1 unless $@;    
    unless($@ =~ /\b(table)\b/) {
	print "warning". "   ! $procname caught unknown exception: $@";
    }
    
    die("$modname$procname"); 

}
    

# Description:
#     Obtains the column names 
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub describe_table($$) { 
    
    my ($dbh, $table) = @_; 

    my $describequery = "describe $table;";    
    
    my @list = (); 
    my $desc = $dbh->prepare($describequery); 	
    $desc->execute();
    while (my $ref = $desc->fetchrow_hashref()) {	    
	push @list, $ref->{'Field'}; 
    };
    
    return \@list; 
}

## Description:
##    Dumps the contents of various tables..
##    
##    
## Arguments:
##     -
## Returns:
##     -
## Exceptions:
##     -
#sub dump_combined_table($$) { 
#
#    my ($conf, $what) = @_; 
#    
#    my $procname = "dump_table";     
#    #print "-> $modname$procname\n"; 
#
#    my $database = $conf->{'database'}; 
#    my $username = $conf->{'user'}; 
#    my $password = $conf->{'password'}; 
#    my $hostname = $conf->{'hostname'}; 
#    
#    
#    eval { 
#	
#	my $dbh = open_dbh($conf); 
#	
#	my $keys = []; 
#	my ($describequery, $dataquery) = ();
#	if ($what =~ /(combined)/i){ 
#	    
#	    my ($keys2);
#	    	    
#	    # Pull all the combinations...
#	    $keys2 = describe_table($dbh, 'exit_stats'); 
#	    push @{$keys}, @{$keys2};	    
#	    $keys2 = describe_table($dbh, 'location'); 
#	    push @{$keys}, @{$keys2};	    
#	    $keys2 = describe_table($dbh, 'time'); 
#	    push @{$keys}, @{$keys2};	    
#	    $keys2 = describe_table($dbh, 'holidays'); 
#	    push @{$keys}, @{$keys2};	    
#	    $keys2 = describe_table($dbh, 'weather'); 
#	    push @{$keys}, @{$keys2};	    
#
#            my $now = time; 
#
#	    $dataquery = 
#	       '
#                SELECT * FROM exit_stats, location, time, holidays, weather
#                WHERE
#                (
#                 (exit_stats.LocalAddressType = location.location_AddressType) AND
#                 (exit_stats.StartTimeSec = time.time_StartTimeSec) AND
#                 (
#                   ((EXISTS (SELECT * from location WHERE 
#                                (exit_stats.RemAddress = location_Address))) AND
#                     (exit_stats.RemAddress =  location.location_Address)
#                    )
#                  OR
#                   ((NOT EXISTS (SELECT * from location WHERE 
#                                 (exit_stats.RemAddress = location_Address))) AND
#                     (location.location_Address = "unknown/location")
#                   )
#                 ) AND
#                 (
#                   (EXISTS (SELECT * from holidays WHERE 
#                                 ((location.location_CountryCode = holidays_Country) AND
#                                  (time.time_Yday = holidays_Day)))
#                   )
#                  OR
#                   (
#                    (NOT EXISTS (SELECT * from holidays WHERE 
#                                 ((location.location_CountryCode = holidays_Country) AND
#                                  (time.time_Yday = holidays_Day)))) AND
#                    (holidays.holidays_Country = "ZZ")
#                   )
#                  ) AND
#                 (
#                   ((EXISTS (SELECT * from weather WHERE 
#	         	((exit_stats.StartTimeSec + 21600 > weather_TimeStamp) OR
#	         	 (weather_TimeStamp + 21600 > exit_stats.StartTimeSec )) AND 
#                        (location.location_City = weather_City) AND 
#                        (location.location_CountryCode3 = weather_CountryCode3))) AND 
#	            ((exit_stats.StartTimeSec + 21600 > weather.weather_TimeStamp) OR
#	             (weather.weather_TimeStamp + 21600 > exit_stats.StartTimeSec )) AND 
#                    (location.location_City = weather.weather_City) AND 
#                    (location.location_CountryCode3 = weather.weather_CountryCode3)
#                   )
#                  OR
#                   ((NOT EXISTS (SELECT * from weather WHERE 
#	         	((exit_stats.StartTimeSec + 21600 > weather_TimeStamp) OR
#	         	 (weather_TimeStamp + 21600 > exit_stats.StartTimeSec )) AND 
#                        (location.location_City = weather_City) AND 
#                        (location.location_CountryCode3 = weather_CountryCode3))) AND 
#                    (weather.weather_CountryCode3 = "ZZZ"))
#                   )
#                );';
#	    
#	} else {
#	    print "Wrong table!\n"; 
#	    die("table");
#	}
#	
#	#print " Data query = $dataquery\n"; 
#	# Print the header...
#	foreach my $key (@{$keys}){
#	    print $key . "\t"; 
#	}	    
#	print "\n"; 
#	
#	# Print the data...
#	my $sth = $dbh->prepare($dataquery); 
#	$sth->execute();		
#	while (my $ref = $sth->fetchrow_hashref()) {	    
#	    
#	    foreach my $attr (@{$keys}){
#		if (defined $ref->{$attr}){ 
#		    #print "($attr " . $ref->{$attr} . " )\t"; 
#		    #print "$attr=>\"" . $ref->{$attr} . "\"\t"; 
#		    print "\"" . $ref->{$attr} . "\"\t"; 
#		} else {
#		    print "-\t";
#		}
#	    }	    
#	    print "\n";
#	}; # for all the fetched rows...
#		
#	# Cleanup
#	$sth->finish();
#
#	# Disconnect from the database.
#	$dbh->disconnect();
#
#    }; # Eval...
#
#    #log "info", "<- $modname$procname $@";
#    return 1 unless $@;
#    
#    unless($@ =~ /\b(geodb)\b/) {
#	print "warning". "   ! $procname caught unknown exception: $@";
#      }
#    
#    return 0; 
#
#}; 

sub fill_defaults {
    
    $defaults{exit_stats} =  {
    };

    $defaults{holidays} =  {
	holidays_Holiday  => 0,
    };

    $defaults{location} =  {
	location_AddressType => 0, 
	location_Address     => 0, 
	location_City        => 0, 
	location_Region      => 0,
	location_CountryCode => 0,
	location_CountryCode3=> 0,
	location_CountryName => 0,
	location_Latitude    => 0,
	location_Longitude   => 0,
	location_PostalCode  => 0, 
    };
    
    $defaults{time} = { 
	time_StartTimeSec => 0,
	time_Sec          => 0,
	time_Min          => 0,
	time_Hour         => 0,
	time_Day          => 0,
	time_Month        => 0,
	time_Year         => 0,
	time_Wday         => 0,
	time_Yday         => 0,
	time_Dlst         => 0
    };
    
    $defaults{weather} = { 
    	weather_window 			=> 21600,   # +/- 6 hours...
        weather_celsius 		=> 0, 
        weather_fahrenheit 		=> 0, 
        weather_temperature_celsius	=> 0, 
        weather_temperature_fahrenheit	=> 0, 
        weather_Conditions     		=> 0, 
        weather_Pressure      		=> 0, 
    };

    $defaults{typemap} = {
	"location_City"                 => "City",
	"location_Region"               => "Region",
	"location_CountryCode"          => "CountryCode",
	"location_CountryCode3"         => "CountryCode3",
	"location_CountryName"          => "CountryName",
    };
    

    #################################################################
    # Store the local interface address. Check the data to skip
    # connections that have local address as their destination 
    # address. Should check the range instead? 
    #################################################################
    if (0) { 
	open(ITF, "ifconfig |") || die("Cannot read the interface configuration"); 
	while(<ITF>){
	    if (/inet addr:(\d+.\d+.\d+.\d+)/){
		my $ip = unpack("N", pack("C4",split(/\./, $1)));
		print "$1 => $ip \n";
		$defaults{localaddress}{$ip} = $1; 
	    }
	};
	close(ITF);     
    }; 

};

# Description:
#     Lookup quantization ranges and compute the enumeration value
#     and the value after quantization corresponding to the 
#     enumeration value.
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub quantize_var ($$) {
    
    my ($attr, $val) = @_; 
    my ($found, $quantizeenum, $quantizedval) = (0,0,0); 
    
    # defaults{quantize} = {
    #                        MaxRTT => { 
    #                                    quantizetype => "range"
    #                                    quantizetable => { 
    #                                          0 => {
    #                                             quantizedval => 200
    #                                             minval => 100
    #                                             maxval => 300
    #                                          }
    #                                          1 => {...
    #                                          }
    #                                     }
    #                                  }

    if (exists $defaults{quantize}{$attr}){
	my $qhash = $defaults{quantize}{$attr};
	my $qtable= $qhash->{quantizetable};
	my $qtype = $_ = $qhash->{quantizetype};
	
	#=> Depending on the type of quantization, we would have to
	#   transform the value...
        SWITCH: { 

	    /range/ and do { 
		# do nothing...
		last SWITCH; 
	    };
	    
	    # Use the range on the log to the base 10...
	    /log10/ and do { 
		if ($val > 0) { $val = log($val)/log(10); }
		last SWITCH; 
	    };
	    
	    do {
		die("Unknown quantization type...");
	    }
	}
	
	foreach my $enum (sort {$a <=> $b} keys %{$qtable}){
	    
	    if (($qtable->{$enum}{minval} <= $val) and 
		($qtable->{$enum}{maxval} >= $val)){
		$quantizedval  = $qtable->{$enum}{quantizedval};
		$quantizeenum = $enum; 
		$found = 1; 
		last; 
	    }; 
	};
    };
    
   #print " [quantize_var] $attr, $val => $found, $quantizeenum, $quantizedval\n";
    return ($found, $quantizeenum, $quantizedval); 
};

# Description:
#
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub process_output_hash ($$) {
    
    my ($outputhash, $quantize) = @_; 
    my $status = 1; 

    return 0 if (ref($outputhash) !~ /HASH/); 
    
    my $msg = "";
    foreach my $attr (keys %{$outputhash}){

	$_ = $attr;
	my $oldval = $outputhash->{$attr}; 
	my $newval = $outputhash->{$attr}; 
        SWITCH: { 
	    
	    /(MinRTT|MaxRTT)/ and do {
		
		# Check for validity...
		if ($outputhash->{$attr} == 2147483647) {
		    $status = 0; 
		    $outputhash->{$attr} = 0; 
		} elsif ($quantize){
		    my ($found, $enum, $qval) = 
			   quantize_var($attr, $outputhash->{$attr});
	    
		    $status = 0 if (! $found);
		    $newval = $enum; 
		    $msg .= "[$attr] $oldval => $newval ";

		};

		last SWITCH; 
	    }; 

	    /RemAddress/ and do {
		$newval = $oldval >> 8;   # use only the top 24 bits..
		$msg .= "[$attr] $oldval => $newval ";
		last SWITCH; 
	    }; 

	    /(PktsIn|PktsOut|MaxCwnd)/ and do {
		my ($found, $enum, $qval) = 
		    quantize_var($attr, $outputhash->{$attr});
		$newval = $enum; 
		$msg .= "[$attr] $oldval => $newval ";
		last SWITCH; 
	    }; 

	    /WinScale/ and do {
		$newval = $oldval + 1; # Convert from -1:14 => 0:15 
		$msg .= "[$attr] $oldval => $newval ";
		last SWITCH; 
	    }; 

	};

	$outputhash->{$attr} = $newval;

    };
    
    #print "[process_output_hash] . $msg\n";
    
    return $status; 
}

# Description:
#     Print the first line of the output - the header. 
#     This will change at a later date...
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub print_header($) { 

    my ($keystable) = @_; 
    my $attr; 
    my ($attrline, $maxline) = ("", "");
    my ($condvars, $outputvars) = (0, 0); 
    
    #=> Print the first line (column headers)....
    # First the condition variables of exit_stats
    foreach my $table ( "exit_stats", "time", "location", "weather" ){ 
	foreach $attr (@{$keystable->{$table}}){
	    if ((exists $ALNConfig::variables->{condition}{$attr}) and 
		($ALNConfig::variables->{condition}{$attr} == 1)){
		$attrline .= "$attr\t";
		$maxline .= $ALNConfig::maxvalues->{$attr} . "\t";
		$condvars++; 
	    };
	};
    };

    #   # time..
    #   foreach $attr (@{$keystable->{time}}){
    #	  #next if ($attr =~ /StartTimeSec/); 
    #	  print "$attr\t" if ((exists $ALNConfig::variables->{condition}{$attr}) and 
    #			    ($ALNConfig::variables->{condition}{$attr} == 1));
    #   }; 
    #    
    #   # location 
    #   foreach $attr (@{$keystable->{location}}){
    #	  #next if ($attr =~ /location_Address/); 
    #	  print "$attr\t" if ((exists $ALNConfig::variables->{condition}{$attr}) and 
    #			    ($ALNConfig::variables->{condition}{$attr} == 1));
    #   }; 
    #    
    #    # weather...
    #   foreach $attr (@{$keystable->{weather}}){
    #	  #next if ($attr =~ /(TimeStamp|City|Region|CountryCode3)/); 
    #	  print "$attr\t" if ((exists $ALNConfig::variables->{condition}{$attr}) and 
    #			    ($ALNConfig::variables->{condition}{$attr} == 1));
    #   }; 
    #	

    # holiday...
    foreach $attr ( "holidays_Holiday" ){
	if ((exists $ALNConfig::variables->{condition}{$attr}) and 
	    ($ALNConfig::variables->{condition}{$attr} == 1)){
	    $attrline .= "$attr\t";
	    $maxline .= $ALNConfig::maxvalues->{$attr} . "\t";
	    $condvars++;
	};
    }; 


    # Condition/output separator..
    $attrline .= "#\t";
    $maxline  .= "#\t";

    # Finally print the output variables...
    foreach $attr (@{$keystable->{exit_stats}}){
	if ((exists $ALNConfig::variables->{output}{$attr}) and 
	    ($ALNConfig::variables->{output}{$attr} == 1)){ 
	    $attrline .= "$attr\t";
	    $maxline .= $ALNConfig::maxvalues->{$attr} . "\t";
	    $outputvars++;
	};
    };
    
    ######################################3
    # Print the header of the combined data table....
    ######################################3
    print ";\n";
    print "; Input for the ALN learning algorithms\n"; 
    print "; \n";
    print "; Date: " . localtime() . "\n";
    print ";\n";
    
    #=> Print the quantization table....
    my $qlines = "; varname\ttype\tminval\tmaxval\tenum\tquantizedval\n";
    foreach my $varname (keys %{$defaults{quantize}}){
	my $entry = $defaults{quantize}{$varname};
	my $type = $entry->{quantizetype}; 
	foreach my $enum (sort {$a <=> $b} keys %{$entry->{quantizetable}}){
	    my $minval = $entry->{quantizetable}{$enum}{minval};
	    my $maxval = $entry->{quantizetable}{$enum}{maxval};
	    my $quantizedval = $entry->{quantizetable}{$enum}{quantizedval};
	    $qlines .= "; $varname\t$type\t$minval\t$maxval\t$enum\t$quantizedval\n";
	};
    };
    
    print "; Quantization Table\n";
    print "; ------------------\n";
    print $qlines; 
    print ";\n;\n";
    print ";conditions\t#\toutputs\n";
    print "$condvars\t#\t$outputvars\n";
    print ";\n";
    print "; Maximum values of the variables\n";
    print ";$attrline\n";
    print "$maxline\n";
    print ";\n";
    
};


# Description:
#     Print one line of the output....
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub print_output_hash($$) { 

    my ($keystable, $outputhash) = @_; 
    my $attr; 

    # Print conditions from the exit_stats...
    foreach $attr (@{$keystable->{exit_stats}}){
	if ((exists $ALNConfig::variables->{condition}{$attr}) and 
	    ($ALNConfig::variables->{condition}{$attr} == 1)){
	    print $outputhash->{$attr} . "\t";
	}
    };
    
    # Print conditions from the time...
    foreach $attr (@{$keystable->{time}}){
	#next if ($attr =~ /StartTimeSec/); 
	if ((exists $ALNConfig::variables->{condition}{$attr}) and 
	    ($ALNConfig::variables->{condition}{$attr} == 1)){
	    print $outputhash->{$attr} . "\t";
	}
    }; 
    
    # location 
    foreach $attr (@{$keystable->{location}}){
	#next if ($attr =~ /location_Address/); 
	if ((exists $ALNConfig::variables->{condition}{$attr}) and 
	    ($ALNConfig::variables->{condition}{$attr} == 1)){
	    print $outputhash->{$attr} . "\t";
	}
    }; 
    
    # weather...
    foreach $attr (@{$keystable->{weather}}){
	next if ($attr =~ /(TimeStamp|City|Region|CountryCode3)/); 
	if ((exists $ALNConfig::variables->{condition}{$attr}) and 
	    ($ALNConfig::variables->{condition}{$attr} == 1)){
	    print $outputhash->{$attr} . "\t";
	}
    }; 
    
    # holiday...
    foreach $attr ( "holidays_Holiday" ){
	if ((exists $ALNConfig::variables->{condition}{$attr}) and 
	    ($ALNConfig::variables->{condition}{$attr} == 1)){
	    print $outputhash->{$attr} . "\t";
	}
    }; 
    
    # Condition/output separator..
    print "#\t";
    
    # Finally print the output variables...
    foreach my $attr (@{$keystable->{exit_stats}}){
	if ((exists $ALNConfig::variables->{output}{$attr}) and 
	    ($ALNConfig::variables->{output}{$attr} == 1)){
	    print $outputhash->{$attr} . "\t";			
	}
    };
    print "\n";

};  # print output line...

# Description:
#
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub process_combined_data($$$) { 
    
    my ($dbh, $data, $quantize) = @_;
    my %keystable = (); 
    my $attr; 

    foreach my $table ('location', 'exit_stats', 'time', 
		       'holidays', 'weather'){
	$keystable{$table} = describe_table($dbh, $table); 
    };
    
    my $strings = $data->{strings};	
    if (not defined $strings){
	print "strings table not defined\n";
	die;
    }
    
    print_header(\%keystable); 

    # 
    #  1.2.3.4 => 
    #             10000 => 
    #                      exit_stats => 
    #                                    LocalAddress => 
    #                                    MaxAppRQueue => 
    #                                    ... 
    #                      location  => 
    #                                    CountryCode => 
    #                                    ...
    #                      time      => 
    #                                    Day => 
    #                                    ...
    #                       ...
    #             10001 => 
    #                      exit_stats => 
    #                                    LocalAddress => 
    #                                    MaxAppRQueue => 
    #                                    ... 
    #                      location  => 
    #                                    CountryCode => 
    #                                    ...
    #                      time      => 
    #                                    Day => 
    #                                    ...
    #                       ...
    #
    #  1.2.1.1 => 
    #             20000 => 
    #                      exit_stats => 
    #                                    LocalAddress => 
    #                                    MaxAppRQueue => 
    #                                    ... 
    #                      location  => 
    #                                    CountryCode => 
    #                                    ...
    #                      time      => 
    #                                    Day => 
    #                                    ...
    #                       ...
    #             20001 => 
    #                      exit_stats => 
    #                                    LocalAddress => 
    #                                    MaxAppRQueue => 
    #                                    ... 
    #                      location  => 
    #                                    CountryCode => 
    #                                    ...
    #                      time      => 
    #                                    Day => 
    #                                    ...
    #                       ...
    #

    my $count = 1; 
    # For all addresses...(not sorted)
    foreach my $RemAddress (keys %{$data->{exit_stats}}){
	# for all times when we connected to the destination...
	foreach my $StartTimeSec (keys %{$data->{exit_stats}{$RemAddress}}){
	    
	    my $exit_stats_entry  = $data->{exit_stats}{$RemAddress}{$StartTimeSec}; 
	    my $time_entry        = $data->{time}{$StartTimeSec}; 
	    my $location_entry    = $data->{location}{$RemAddress}; 
	    

	    # There could be multiple entries for a given (addr, time) 
	    # combination...
	    foreach my $token (keys %{$exit_stats_entry}){

		#print "Entry $count ($RemAddress, $StartTimeSec, $token)\n"; 
		$count++;

		
		# First collect the output into a simple hash and then 
		# output it based on rules for (ordering, skipping, precision?) 
		# 
		my %outputhash = (); 
		
		############################
		#=> Gather all the exit_stats variables...conditions and outputs.
		############################
		foreach $attr (@{$keystable{exit_stats}}){
		    my $attrval =$ exit_stats_entry->{$token}{$attr};
		    if ($attr =~ /^(LocalAddress|RemAddress)$/i){
			#=> Convert ip address into number...
			my $ip = unpack("N", pack("C4",split(/\./,$attrval)));
			$outputhash{$attr} = $ip;
		    } else {
			$outputhash{$attr} = $attrval;
		    }; 
		};
		
		############################		    
		#=> Time, location etc...are among the conditions too 
		# so print them without hesitation...
		############################

		#=> Here the entries from the rest of the tables 
		# comes into picture....
		foreach $attr (@{$keystable{time}}){
		    next if ($attr =~ /StartTimeSec/); 
		    if (defined $time_entry){
			$outputhash{$attr} = $time_entry->{$attr};
		    } else { 
			$outputhash{$attr} = $defaults{time}{$attr};
		    };		    
		};

		my ($year, $day) = (undef, undef);
		if (defined $time_entry){
		    $year = $time_entry->{time_Year}; 
		    $day = $time_entry->{time_Day}; 
		}; 

		#=> For the location information...
		foreach $attr (@{$keystable{location}}){
		    # This also takes care of AddressType which is redundant
		    next if ($attr =~ /location_Address/); 
		    
		    if (defined $location_entry){			
			
			# location_CountryName -> CountryName 
			my $type = $defaults{typemap}{$attr};
			
			# E.g., USA 
			my $name = $location_entry->{$attr}; 

			#=> If there is a code associated with this 
			# attribute, then use it.
			my $enum = undef;
			if (defined $type and 
			    exists $strings->{$type} and 
			    exists $strings->{$type}{$name}) {
			    $enum = $strings->{$type}{$name};
			}
			
			if (defined $enum){			    
			    $outputhash{$attr} =  $enum;
			} else {
			    $outputhash{$attr} = $name;
			}
		    } else { 
			$outputhash{$attr} = $defaults{location}{$attr};
		    };
		};

		############################
		#=> Now look for weather information...
		############################

		# First extract the location information...
		my ($city, $region, $countrycode, $countrycode3) = (undef, undef, undef, undef); 
		if (defined $location_entry){
		    $city = $location_entry->{location_City}; 
		    $region = $location_entry->{location_Region}; 
		    $countrycode = $location_entry->{location_CountryCode}; 
		    $countrycode3 = $location_entry->{location_CountryCode3}; 
		}; 
		
		# Second, find a good match if it exists...
		my $weather_entry = undef; 
		if (( defined $data->{weather} ) and 
                    ( defined $countrycode3 and defined $data->{weather}{$countrycode3}) and 
                    ( defined $region and defined $data->{weather}{$countrycode3}{$region} ) and 
                    ( defined $city and defined $data->{weather}{$countrycode3}{$region}{$city})){
		    
		    # Is there data from a window...
		    my $cityinfo = $data->{weather}{$countrycode3}{$region}{$city};
		    my ($match_time, $match_distance)= (undef, 99999999); 
		    foreach my $timestamp (keys %{$cityinfo}){
			my $distance = abs($StartTimeSec - $timestamp);
			if (($distance <  $defaults{weather}{weather_window}) and 
			    ($distance < $match_distance)){
			    $match_distance = $distance;
			    $match_time = $timestamp; 
			};
		    };
		    
		    if (defined $match_time){
			$weather_entry = $cityinfo->{$match_time};
		    }

		};

		############################
		#=> For the location information...
		############################
		foreach $attr (@{$keystable{weather}}){
		    # This also takes care of AddressType which is redundant
		    next if ($attr =~ /(TimeStamp|City|Region|CountryCode3)/); 
		    if (defined $weather_entry){
			$outputhash{$attr} =  $weather_entry->{$attr};
		    } else { 
			$outputhash{$attr} = $defaults{weather}{$attr};
		    };
		};

		############################		
		#=> Now check if the day indicated is a holiday... 
		############################
		$attr = "holidays_Holiday"; 
		my $holidays_entry = undef; 
		if (( defined $data->{holidays} ) and 
                    ( defined $countrycode and defined $data->{holidays}{$countrycode}) and 
                    ( defined $year and defined $data->{holidays}{$countrycode}{$year} ) and 
                    ( defined $day and defined $data->{holidays}{$countrycode}{$year}{$day})){
		    
                    my $holidays_entry = $data->{holidays}{$countrycode}{$year}{$day};
		    $outputhash{$attr} = $holidays_entry->{holidays_Holiday};
		} else { 
		    $outputhash{$attr} = $defaults{holidays}{holidays_Holiday};
		};


		
		#############################################################
		# Post process all the data collected...Quantize in the 
		# otuput processing function.
		#############################################################
		my $accept = process_output_hash(\%outputhash, $quantize);
		next if (not $accept); 

		#############################################################
		# Print the output now.....
		#############################################################
		print_output_hash(\%keystable, \%outputhash);

	    };

	}; # foreach exit_stats combination of (address and time) 
    };
};


# Description:
#     Load the quantization table and update the maximum values. 
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub load_quantization_table($) { 
    
    my ($dbh) = @_; 

    my %maxvalues = (); 
    
    my $dataquery = "SELECT * FROM quantize;"; 
    my $sth = $dbh->prepare($dataquery); 
    $sth->execute();		
    while (my $ref = $sth->fetchrow_hashref()) {	    

	#=> For each record...
	my $varname       = $ref->{varname}; 
	my $quantizetype  = $ref->{quantizetype}; 
	my $minval        = $ref->{minval}; 
	my $maxval        = $ref->{maxval}; 
	my $quantizedenum = $ref->{quantizedenum}; 
	my $quantizedval  = $ref->{quantizedval}; 

	if  ( not defined $defaults{quantize}{$varname} or 
	      not defined $defaults{quantize}{$varname}{quantizetype}){
	    $defaults{quantize}{$varname}{quantizetype} = $quantizetype;
	};
	
	$defaults{quantize}{$varname}{quantizetable}{$quantizedenum} = 
	{		
	    minval       => $minval,
	    maxval       => $maxval,
	    quantizedval => $quantizedval,
	};
	
	# Save the maximum value of each variable....
	if (not defined $maxvalues{$varname}){
	    $maxvalues{$varname} = $quantizedenum; 
	} else {
	    if ( $maxvalues{$varname} < $quantizedenum){
		$maxvalues{$varname} = $quantizedenum; 
	    }; 
	}
    };
    $sth->finish();
    
    #=> Now copy the maximum values to ALNConfig variable 
    foreach my $varname (keys %maxvalues){
	#print "Updating value of $varname from	" . 
	#    $ALNConfig::maxvalues->{$varname} . " => " .  
	#    $maxvalues{$varname} ."\n";
	$ALNConfig::maxvalues->{$varname} = $maxvalues{$varname}; 
    };
    
};

# Description:
#    Dumps the contents of various tables..
#    in the early implementation, I tried to run a sql query but 
#    it was turning out to be complex and time consuming (6-way join) 
#    The time part may be an issue with the mysql configuration we are 
#    using...
# 
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub dump_combined_table($) { 

    my ($conf) = @_; 

    my $procname = "dump_combined_table";     
    #print "-> $modname$procname\n"; 

    eval { 
	
	my $dbh = open_dbh($conf); 
	my ($dataquery, $sth) = ();
	my %data = (); 

	fill_defaults(\%defaults); 

	#=> Read the quantization map....varname -> enum -> (value,
	# range object)..
	load_quantization_table($dbh) if ($conf->{quantize} == 1);
	    
	
	#=> First read the time table..
	$dataquery = "SELECT * FROM time;"; 
	$sth = $dbh->prepare($dataquery); 
	$sth->execute();		
	while (my $ref = $sth->fetchrow_hashref()) {	    
	    #=> For each record...
	    my $time = $ref->{time_StartTimeSec}; 
	    foreach my $attr (keys %{$ref}){
		next if (not defined $ref->{$attr});
		#next if ($attr !~ /StartTimeSec/); 
		$data{time}{$time}{$attr} = $ref->{$attr}; 
	    };
	};
	$sth->finish();

	#=> First full 
	$dataquery = "SELECT * FROM strings;"; 
	$sth = $dbh->prepare($dataquery); 
	$sth->execute();		
	while (my $ref = $sth->fetchrow_hashref()) {	    
	    #=> For each record...
	    my $type = $ref->{string_type}; 
	    my $name = $ref->{string_name}; 
	    my $enum = $ref->{string_enum}; 
	    $data{strings}{$type}{$name} = $enum; 
	};
	$sth->finish();

	#=> First full up the location table...
	$dataquery = "SELECT * FROM holidays;"; 
	$sth = $dbh->prepare($dataquery); 
	$sth->execute();		
	while (my $ref = $sth->fetchrow_hashref()) {	    
	    #=> For each record...
	    my $country = $ref->{holidays_Country}; 
	    my $year = $ref->{holidays_Year}; 
	    my $day = $ref->{holidays_Day}; 
	    my $holiday = $ref->{holidays_Holiday}; 
	    
	    foreach my $attr (keys %{$ref}){
		next if (not defined $ref->{$attr});
		#next if ($attr !~ /^...$/);
		$data{holidays}{$country}{$year}{$day}{$attr} = $ref->{$attr};
	    }	    
	};
	$sth->finish();

	#=> First full up the time table..
	$dataquery = "SELECT * FROM location;"; 
	$sth = $dbh->prepare($dataquery); 
	$sth->execute();		
	while (my $ref = $sth->fetchrow_hashref()) {	    
	    #=> For each record...
	    my $addr = $ref->{location_Address}; 
	    foreach my $attr (keys %{$ref}){
		next if (not defined $ref->{$attr});
		#next if ($attr !~ /^location_Address$/);
		$data{location}{$addr}{$attr} = $ref->{$attr}; 
	    }	    
	};
	$sth->finish();
	
	#=> Load the weather table...
	$dataquery = "SELECT * FROM weather;"; 
	$sth = $dbh->prepare($dataquery); 
	$sth->execute();		
	while (my $ref = $sth->fetchrow_hashref()) {	    
	    #=> For each record...
	    my $time = $ref->{weather_TimeStamp}; 
	    my $city = $ref->{weather_City}; 
	    my $region = $ref->{weather_Region}; 
	    my $country = $ref->{weather_CountryCode3}; 
	    
	    foreach my $attr (keys %{$ref}){
		next if (not defined $ref->{$attr});
		#next if ($attr =~ /(TimeStamp|City|Region|CountryCode3)/);
		$data{weather}{$country}{$region}{$city}{$time}{$attr} = $ref->{$attr};
	    };
	};
	$sth->finish();
	

	#=> Load the exit_stats...adding a count to take care of the situation 
	# where there are multiple entries for a given destination address 
	# and time...
	$dataquery = "SELECT * FROM exit_stats WHERE LocalAddressType = 1 " . 
	             "LIMIT 1,1000" . 
		     ";"; 
	$sth = $dbh->prepare($dataquery); 
	$sth->execute();		
	my $count = 0; 

	#=> Ignore addresses in this range...
	#my $minISIaddr = unpack("N", pack("C4",split(/\./,"128.9.0.0")));
	#my $maxISIaddr = unpack("N", pack("C4",split(/\./,"128.9.255.255")));
		     
	while (my $ref = $sth->fetchrow_hashref()) {	    
	    #=> For each record...
	    my $time = $ref->{StartTimeSec}; 
	    my $addr = $ref->{RemAddress}; 

	    if (not defined $time or not defined $addr) {
		print "Error! addr or time are defined\n";
		next;
	    }
	    
	    # Skip connections to within ISI...
	    #my $addrip = unpack("N", pack("C4",split(/\./,$addr)));
	    #next if ($addrip >= $minISIaddr and $addrip <= $maxISIaddr); 

	    foreach my $attr (keys %{$ref}){
		next if (not defined $ref->{$attr});
		#next if ($attr =~ /(StartTimeSec|RemAddress)/);
		$data{exit_stats}{$addr}{$time}{$count}{$attr} = $ref->{$attr};
	    };
	    $count++; 
	};
	$sth->finish();
	
	############################
        # Ok. Now process the exit_stats connection table....
	###########################
	
	process_combined_data($dbh, \%data, $conf->{quantize}); 

	# Disconnect from the database.
	$dbh->disconnect();


	
    }; # Eval...

    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@ =~ /\b(geodb)\b/) {
	print "warning". "   ! $procname caught unknown exception: $@";
      }
    
    return 0; 

}; 

# Description:
#    Dumps the contents of various tables..
#    
#    
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub dump_table($$) { 

    my ($conf, $what) = @_; 
    
    my $procname = "dump_table";     
    #print "-> $modname$procname\n"; 

    eval { 
	
	# Connect to the database.
	my $dbh = open_dbh($conf); 
	
	my $keys = []; 
	my ($describequery, $dataquery) = ();
	if ($what =~ /(location)/i){ 
	    $keys = describe_table($dbh, 'location'); 
	    $dataquery = "SELECT * from location;";
	} elsif ($what =~ /(exit_stats)/i){ 
	    $keys = describe_table($dbh, 'exit_stats'); 
	    $dataquery = "SELECT * from exit_stats WHERE LocalAddressType = 1;";
	} elsif ($what =~ /(time)/i){ 
	    $keys = describe_table($dbh, 'time'); 
	    $dataquery = "SELECT * from time;";
	} elsif ($what =~ /(holidays)/i){
	    $keys = describe_table($dbh, 'holidays');
	    $dataquery = "SELECT * from holidays;";
	} elsif ($what =~ /(weather)/i){
	    $keys = describe_table($dbh, 'weather');
	    $dataquery = "SELECT * from weather;";
	} elsif ($what =~ /(strings)/i){
	    $keys = describe_table($dbh, 'strings'); 
	    $dataquery = "SELECT * from strings;";
	} elsif ($what =~ /(quantize)/i){ 
	    $keys = describe_table($dbh, 'quantize'); 
	    $dataquery = "SELECT * from quantize;";
	} else {	
	    print "Wrong table!\n"; 
	    die("table");
	}
	
	#print " Data query = $dataquery\n"; 
	# Print the header...
	foreach my $key (@{$keys}){
	    print $key . "\t"; 
	}	    
	print "\n"; 
	
	# Print the data...
	my $sth = $dbh->prepare($dataquery); 
	$sth->execute();		
	while (my $ref = $sth->fetchrow_hashref()) {	    
	    
	    foreach my $attr (@{$keys}){
		if (defined $ref->{$attr}){ 
		    #print "($attr " . $ref->{$attr} . " )\t"; 
		    #print "$attr=>\"" . $ref->{$attr} . "\"\t"; 
		    #print "\"" . $ref->{$attr} . "\"\t"; 
		    print $ref->{$attr} . "\t"; 
		} else {
		    print "-\t";
		}
	    }	    
	    print "\n";
	}; # for all the fetched rows...
		
	# Cleanup
	$sth->finish();

	# Disconnect from the database.
	$dbh->disconnect();

    }; # Eval...

    #log "info", "<- $modname$procname $@";
    return 1 unless $@;
    
    unless($@ =~ /\b(geodb)\b/) {
	print "warning". "   ! $procname caught unknown exception: $@";
      }
    
    return 0; 

}; 


# Description:
#     Identifies the new destination addresses in the database, 
#     obtains their location information and dumps it into another 
#     table. 
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub init_database($) { 

    my ($conf) = @_; 
    
    my $procname = "init_database";
    
    #print "-> $modname$procname\n"; 
    eval { 
	
	my $killdatabase = 0; 

	print "Do you want to destroy the old database and create a new one [y|n]?";
	while (<STDIN>){
	    unless (/(y|n)/i){
		print "please enter y or n:";
		next;
	    }
	    $killdatabase = 1 if (/y/i);
	    last;
	}; 
	
	if ($killdatabase) {
	    
	    print "Ok! Reinitializing the database\n";

	    my $username = $conf->{'user'}; 
	    my $password = $conf->{'password'}; 
	    my $hostname = $conf->{'hostname'}; 
	    my $dbh; 
	    
	    # Connect to the mysql...
	    $dbh = DBI->connect("DBI:mysql:host=$hostname",
				$username, $password, 
				{RaiseError => 1});
	
	    $dbh->trace($trace); 
	    
	    #=> Dont worry if this fails...
	    eval { 
		my $sql =   "DROP DATABASE IF EXISTS alndb; "; 
		my $drop = $dbh->prepare($sql); 
		$drop->execute();
		$drop->finish(); 
	    }; 
	    
	    
	    my $sql =   "CREATE DATABASE alndb; "; 
	    my $create = $dbh->prepare($sql); 
	    $create->execute();
	    $create->finish();
	    
	    $dbh->disconnect();
	    
	    init_table($conf, "exit_stats");
	    init_table($conf, "location");
	    init_table($conf, "time");
	    init_table($conf, "weather");
	    init_table($conf, "holidays");
	    init_table($conf, "strings");
	    init_table($conf, "quantize");

	};

    }; #eval...

    if ($@) {
      print "Received exception $@";
    }
};
 
# Description:
#     Identifies the new destination addresses in the database, 
#     obtains their location information and dumps it into another 
#     table. 
# Arguments:
#     -
# Returns:
#     -
# Exceptions:
#     -
sub init_table($$) { 

    my ($conf, $table) = @_; 
    
    my $procname = "init_table";
    
    #print "-> $modname$procname\n"; 
    eval { 
	
	die "Unknown table" if 
	    ($table !~ /(location|holidays|time|weather|exit_stats|strings|quantize)/);

        print "Connecting to the database\n";

	# Connect to the database.
	my $dbh = open_dbh($conf); 
	
        print "Connected. Executing query"; 

	# delete the existing table...
	my $sqldrop =   "DROP TABLE IF EXISTS $table; "; 
	my $drop = $dbh->prepare($sqldrop); 
	$drop->execute();
	$drop->finish(); 
	
	# Now create the new database...
	my $sqlcreate =  ""; 

	if ($table =~ /(location)/){ 
	    # Location database 
	    $sqlcreate =  
                       'CREATE TABLE location (  
			    location_AddressType   int(1)       NOT NULL      COMMENT "IPv4 = 1 IPv6 = 2",
			    location_Address       varchar(128) NOT NULL      COMMENT "IP address of a connection end point" ,
			    location_City          varchar(128) DEFAULT "-"   COMMENT "Full name of the city" ,
			    location_Region        varchar(128) DEFAULT "-"   COMMENT "Region name May be undefined" ,
			    location_CountryCode   varchar(2)   DEFAULT "US"  COMMENT "Two letter country code" ,
			    location_CountryCode3  varchar(3)   DEFAULT "USA" COMMENT "Three letter code of the country" ,
			    location_CountryName   varchar(128) DEFAULT "-"   COMMENT "Full name of the country" ,
			    location_Latitude      varchar(128) DEFAULT "-"   COMMENT "Geographical coordinates" ,
			    location_Longitude     varchar(128) DEFAULT "-"   COMMENT "Geographical coordinates" ,
			    location_PostalCode    int(11)      DEFAULT "0"   COMMENT "Postal area code Not always available" 
			 );';

	} elsif ($table =~ /(time)/){ 
	    # holidays database
	    # This is only local information...
	    $sqlcreate =  
		'CREATE TABLE time ( 
	             time_StartTimeSec  bigint(11) COMMENT "Start time of the connection",
	             time_Sec           int(2)     COMMENT "Convert StartTimeSec into 0-59 sec",
	             time_Min           int(2)     COMMENT "Convert StartTimeSec into 0-59 min",
	             time_Hour          int(2)     COMMENT "Convert StartTimeSec into 0-23 hours",
	             time_Day           int(2)     COMMENT "Convert StartTimeSec into 0-30 day of the month",
	             time_Month         int(2)     COMMENT "Convert StartTimeSec into 0-11 months",
	             time_Year          int(2)     COMMENT "Convert StartTimeSec into year since 1900",
	             time_Wday          int(2)     COMMENT "Convert StartTimeSec into day of the week",
	             time_Yday          int(3)     COMMENT "Convert StartTimeSec into 0-365 day of the year",
	             time_Dlst          int(1)     COMMENT "Day light saving enabled?"
		     );
                 '; 	    
	} elsif ($table =~ /(holidays)/){ 
	    # holidays database
	    # This is only local information...
	    $sqlcreate =  
		'CREATE TABLE holidays ( 
	             holidays_Country         varchar(2),
	             holidays_Year            int(4),
	             holidays_Day             int(3),
	             holidays_Holiday         varchar(128)
		     );
                ';
	} elsif ($table =~ /(weather)/){ 
	    # holidays database
	    # This is only local information...
	    $sqlcreate =  
		'CREATE TABLE weather ( 
	             weather_TimeStamp              bigint(11) COMMENT "Time when the weather was recorded",
                     weather_City                   varchar(128),
                     weather_Region                 varchar(128),
	             weather_CountryCode3           varchar(3),
                     weather_celsius                int(3),
                     weather_fahrenheit             int(3),
                     weather_temperature_celsius    int(3),
                     weather_temperature_fahrenheit int(3),
                     weather_Conditions             varchar(128), 
                     weather_Pressure               varchar(128)
		     );
                ';
	} elsif ($table =~ /(exit_stats)/){ 
	    $sqlcreate =  
	    'CREATE TABLE exit_stats (
                         LocalAddressType 	int(11),
			 LocalAddress           varchar(128),
			 LocalPort 		int(11),
			 RemAddress             varchar(128),
			 RemPort 		int(11),
			 X_RcvRTT 		int(11),
			 MinRwinRcvd 		int(11),
			 MaxRwinRcvd 		int(11),
			 CurRwinRcvd 		int(11),
			 X_dbg4 		int(11),
			 X_dbg3 		int(11),
			 X_dbg2 		int(11),
			 X_dbg1 		int(11),
			 X_wnd_clamp 		int(11),
			 X_rcv_ssthresh 	int(11),
			 MaxAppRQueue 		int(11),
			 CurAppRQueue 		int(11),
			 MaxReasmQueue 		int(11),
			 CurReasmQueue 		int(11),
			 DupAcksOut 		int(11),
			 LimRwin 		int(11),
			 MinRwinSent 		int(11),
			 MaxRwinSent 		int(11),
			 CurRwinSent 		int(11),
			 MaxAppWQueue 		int(11),
			 CurAppWQueue 		int(11),
			 MaxRetxQueue 		int(11),
			 CurRetxQueue 		int(11),
			 X_Rcvbuf 		int(11),
			 X_Sndbuf 		int(11),
			 MinMSS 		int(11),
			 MaxMSS 		int(11),
			 CurMSS 		int(11),
			 MinRTO 		int(11),
			 MaxRTO 		int(11),
			 CurRTO 		int(11),
			 CountRTT 		int(11),
			 MinRTT 		int(11),
			 MaxRTT 		int(11),
			 RTTVar 		int(11),
			 SmoothedRTT 		int(11),
			 SampleRTT 		int(11),
			 DSACKDups 		int(11),
			 AckAfterFR 		int(11),
			 NonRecovDA 		int(11),
			 RetranThresh 		int(11),
			 QuenchRcvd 		int(11),
			 SendStall 		int(11),
			 ECERcvd 		int(11),
			 PostCongCountRTT 	int(11),
			 PostCongSumRTT 	int(11),
			 PreCongSumRTT 		int(11),
			 PreCongSumCwnd 	int(11),
			 SACKBlocksRcvd 	int(11),
			 SACKsRcvd 		int(11),
			 DupAcksIn 		int(11),
			 BytesRetrans 		int(11),
			 PktsRetrans 		int(11),
			 AbruptTimeouts 	int(11),
			 CurTimeoutCount 	int(11),
			 SubsequentTimeouts 	int(11),
			 Timeouts 		int(11),
			 FastRetran 		int(11),
			 MinSsthresh 		int(11),
			 MaxSsthresh 		int(11),
			 LimCwnd 		int(11),
			 CurSsthresh 		int(11),
			 MaxCwnd 		int(11),
			 CurCwnd 		int(11),
			 CongestionOverCount 	int(11),
			 X_OtherReductionsCM 	int(11),
			 X_OtherReductionsCV 	int(11),
			 OtherReductions 	int(11),
			 CongestionSignals 	int(11),
			 CongAvoid 		int(11),
			 SlowStart 		int(11),
			 SndLimTimeRwin 	int(11),
			 SndLimTransRwin 	int(11),
			 SndLimTimeCwnd 	int(11),
			 SndLimTransCwnd 	int(11),
			 SndLimTimeSender 	int(11),
			 SndLimTransSender 	int(11),
			 StartTimeUsec 		int(11),
			 StartTimeSec 		int(11),
			 RecvISS 		int(11),
			 RcvNxt 		int(11),
			 SndISS 		int(11),
			 SndMax 		int(11),
			 SndNxt 		int(11),
			 SndUna 		int(11),
			 DataPktsIn 		int(11),
			 PktsIn 		int(11),
			 DataPktsOut 		int(11),
			 PktsOut 		int(11),
			 WinScaleSent 		int(11),
			 WinScaleRcvd 		int(11),
			 MSSRcvd 		int(11),
			 ActiveOpen 		int(11),
			 RcvWinScale 		int(11),
			 SndWinScale 		int(11),
			 ECNEnabled 		int(11),
			 NagleEnabled 		int(11),
			 TimestampsEnabled 	int(11),
			 SACKEnabled 		int(11),
			 State			int(11),
			 WAD_Kaicnt 		int(11),
			 WAD_CwndAdjust 	int(11),
			 WAD_NoAI 		int(11),
			 WAD_MD 		int(11),
			 WAD_AI 		int(11),
			 WAD_FloydAIMD 		int(11),
			 WAD_MaxSsthresh 	int(11),
			 WAD_MaxBurst 		int(11),
			 WAD_IFQ 		int(11),
			 SumRTT 		bigint(20),
			 SndLimBytesRwin 	bigint(20),
			 SndLimBytesCwnd 	bigint(20),
			 SndLimBytesSender 	bigint(20),
			 Duration 		bigint(20),
			 ThruBytesReceived 	bigint(20),
			 ThruBytesAcked 	bigint(20),
			 DataBytesIn 		bigint(20),
			 DataBytesOut 		bigint(20)
                );'; 

	} elsif ($table =~ /(strings)/){ 
	    # This will contain a table of strings mapped to 
	    # enumeration numbers..
	    $sqlcreate =  
		'CREATE TABLE strings ( 
	             string_type             varchar(128),
	             string_name             varchar(128),
	             string_enum             int(11)
		     );

                ';
	} elsif ($table =~ /(quantize)/){ 
	    # This will contain a table of strings mapped to 
	    # enumeration numbers..	    
	    $sqlcreate =  
		'CREATE TABLE quantize ( 
	             varname        varchar(128),
                     quantizetype   varchar(128),
	             minval         int(11),
	             maxval         int(11),
                     quantizedenum  int(11),
	             quantizedval   int(11)
		     );
                ';
	};

	die if ($sqlcreate eq ""); 

	print $sqlcreate; 

	my $create = $dbh->prepare($sqlcreate); 
	$create->execute();
	$create->finish();

	print "Create completed\n"; 
	
	# Insert from null entries to catch all defaults...
	if ($table =~ /(location)/){
	    my @cmd = ("insert into location values (?,?,?,?,?,?,?,?,?,?)",
		       undef, 
		       1, "unknown/location", "-", "-", "ZZ", "ZZZ", 
		       "-", "-", "-", 0); 
	    $dbh->do(@cmd);  
	    
	} elsif ($table =~ /(holidays)/){

	    my @cmd = ("insert into holidays values (?,?,?,?)",
		       undef, "ZZ", 0, 0, "unknown/noholiday");
	    
	    $dbh->do(@cmd);  

	} elsif ($table =~ /(weather)/){

	    my @cmd = ("insert into weather values (?,?,?,?,?,?,?,?,?,?)",
		       undef, 0, "-", "-", "ZZZ", 0,0,0,0,"unknown/conditions", "-");
	    
	    $dbh->do(@cmd);  
	};

	# Disconnect from the database.
	$dbh->disconnect();
	
    }; # Eval...
 
    if ($@) {
      print "Received exception $@";
    }
    
}; 

sub Usage () { 
	  print "alndb.pl [-h|-help]\n\t|[[-d|-dump]" .
	      " [location|exit_stats|holidays|weather|strings|quantize|combined]]\n".
	      "\t|[[-i|-initialize] [all|location|time|holidays|weather|strings|exit_stats|quantize]]\n". 
	      "\t|[[-u|-update] [all|location|time|weather|holidays|quantize|strings]]\n"; 
	  print "Details:\n"; 
	  print "        -h|-help: Print this message\n"; 
	  print "        -d|-dump: Dump the contents of the specified table\n"; 
	  print "        -i|-initialize: Create the table specified (destroy\n".
	        "                    old table if necessary. \n"; 
	  print "        -u|-update: Update the location database with\n".
	        "                    information on recent destination IPs\n";
};

eval { 
    
    my ($what); 
    
    #XXX This should be another function...
    my %conf = ( 'database' => 'alndb',
		 'username' => 'root',
		 'password' => '', 
		 'hostname' => 'localhost',
		 'quantize' => 1, 
		 );
    
    $_ = shift @ARGV; 
    $_ = "-help" if (not defined $_); 
    
  SWITCH: {
      
      /^-(help|h)$/ && do {  
	  Usage();  
	  exit; 
      }; 
      
      /^-(dump|d)$/ && do {  	 
	  $what = shift @ARGV; 
	  if (not defined $what or $what !~ /(location|time|exit_stats|weather|combined|holidays|strings|quantize)/i){ 
              Usage();
	      die("arg") 
          };

          if ($what !~ /combined/) { 
	     dump_table(\%conf, $what)
          } else { 
	     dump_combined_table(\%conf);
          };
	  last SWITCH;
      }; 
      
      /^-(update|u)$/ && do {  	 
	  $what = shift @ARGV; 
	  if (not defined $what or $what !~ /(all|location|holidays|time|weather|strings|quantize)/i){
              Usage();
              die;
 	  };

	  if ($what !~ /all/){ 
	      update_table(\%conf, $what); 
	  } else {	
	      #=> These have to be done in particular order....
	      print "This does not update exit_stats or strings table. They have " .
		  "to initialized separate and in case of strings table, we can ". 
		  "update the table again from Geo::IP strings\n";
	      update_table(\%conf, "time"); 
	      update_table(\%conf, "location");
	      update_table(\%conf, "weather");      
	  }
	  last SWITCH; 
      }; 
      
      /^-(initialize|i)$/ && do {  	 
	  $what = shift @ARGV; 
	  die("arg") if (not defined $what or 
			 $what !~ /^(all|location|holidays|time|weather|exit_stats|strings|quantize)$/i); 
	  if ($what !~ /all/){
	      init_table(\%conf, $what); 
	  } else {
	      init_database(\%conf);
	  };
	  last SWITCH;
      }; 
      
  };

}; # Eval...

if ($@){
    if ($@ =~ /(arg)/){
	print "Error in arguments!\n";
	die; 
    } else {
	print "Unknown error! $@\n";
	die; 
    }
}
1; 

#my $weather = 
#    Weather::Underground->new(
#			      place => "$city, $region, $country_name",
#			      debug => 0,
#			      )
#    || die "Error, could not create new weather object: $@\n"; 
#
#my $arrayref = $weather->get_weather()
#    || die "Error, calling get_weather() failed: $@\n";
#	
#foreach (@$arrayref) {
#    print "MATCH:\n";
#    while ( my ($key, $value) = each %{$_}) {
#		print "\t$key = $value\n";
#    }
#};

#
#
## Drop table . This may fail, if foo doesnt exist.
## Thus we put an eval around it.
#eval { $dbh->do("DROP TABLE foo") };
#print "Dropping foo failed: $@\n" if $@;
#
## Create a new table foo. This must not fail, thus we dont
## catch errors.
#$dbh->do("CREATE TABLE foo (id INTEGER, name VARCHAR(20))");
## INSERT some data into foo. We are using $dbh->quote() for
## quoting the name.
#$dbh->do("INSERT INTO foo VALUES (1, " . $dbh->quote("Tim") . ")");
## Same thing, but using placeholders
#$dbh->do("INSERT INTO foo VALUES (?, ?)", undef, 2, "Jochen");
#
## Now retrieve data from the table.
#my $sth = $dbh->prepare("SELECT * FROM foo");
#$sth->execute();
#while (my $ref = $sth->fetchrow_hashref()) {
#    print "Found a row: id = $ref->{id}, name = $ref->{name}\n";
#}
#
#$sth->finish();
#
#my @prefixes = qw ( 128.9.0.0/16 206.117.0.0/16 ); 



